 /*
  * Unitex
  *
  * Copyright (C) 2001-2006 Universit de Marne-la-Valle <unitex@univ-mlv.fr>
  *
  * This library is free software; you can redistribute it and/or
  * modify it under the terms of the GNU Lesser General Public
  * License as published by the Free Software Foundation; either
  * version 2.1 of the License, or (at your option) any later version.
  *
  * This library is distributed in the hope that it will be useful,
  * but WITHOUT ANY WARRANTY; without even the implied warranty of
  * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
  * Lesser General Public License for more details.
  * 
  * You should have received a copy of the GNU Lesser General Public
  * License along with this library; if not, write to the Free Software
  * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA.
  *
  */

//---------------------------------------------------------------------------
#include <stdio.h>
#include <stdlib.h>
#include <string.h>
//---------------------------------------------------------------------------
#include "unicode.h"
#include "Text_tokens.h"
#include "String_hash.h"
#include "Liste_nombres.h"
#include "Alphabet.h"
#include "Matches.h"
#include "Concordance.h"
#include "FileName.h"
#include "Copyright.h"
#include "LocatePattern.h"
#include "ConcordMain.h"
#include "IOBuffer.h"

//---------------------------------------------------------------------------


//
//
//  "E:\My Unitex\English\Corpus\ivanhoe_snt\concord.ind" "Courier new" 3 40 55 CL html "E:\My Unitex\English\Alphabet_sort.txt"
//
//---------------------------------------------------------------------------


void usage() {
printf("%s",COPYRIGHT);
printf("Usage: Concord <concor> <font> <fontsize> <l> <r> <order> <mode> <alph> [-thai]\n");
printf("   <concord> : the concord.ind file generated by the locate program\n");
printf("   <font> : the font you want to use\n");
printf("   <fontsize> : the font size\n");
printf("   <l> : left context length in chars\n");
printf("   <r> : right context length in chars\n");
printf("   <order> : sort order:\n");
printf("           TO : text order\n");
printf("           LC : left, center\n");
printf("           LR : left, right\n");
printf("           CL : center, left\n");
printf("           CR : center, right\n");
printf("           RL : right, left\n");
printf("           RC : right, center\n");
printf("           NULL : specifies no order (used for non-html <mode>)\n");
printf("   <mode> : the mode to be used:\n");
printf("            html : produces an HTML concordance file\n");
printf("            text : produces a plain text concordance file\n");
printf("            glossanet=<script> : produces a glossanet HTML concordance file\n");
printf("            (txt) : produces a file named (txt) which is the SNT file\n");
printf("                    merged with the match results\n");
printf("   <alph> : the char order file used for sorting\n");
printf("            NULL if no alphabet is given\n");
printf("   [-thai] : option to use for thai concordances\n");
printf("\nExtracts the matches stored in <concor>, and stores them into a UTF-8\n");
printf("HTML file saved in the <concor> directory or produces a text file, according\n");
printf("to the <mode> parameter\n");
printf("\nExamples:\n");
printf("Concord tutu.ind \"Courier New\" 12 40 40 TO html \"d:\\My dir\\alph.txt\"\n");
printf("    -> produces an HTML file\n");
printf("\n");
printf("Concord tutu.ind NULL 0 0 0 NULL \"C:\\My dir\\RES.SNT\" NULL\n");
printf("    -> produces a text file named \"C:\\My dir\\RES.SNT\"\n");
}

int main(int argc, char **argv) {
setBufferMode();

if (argc!=9 && argc!=10 && argc!=11) {
   usage();
   return 0;
}
return main_concord_cpp(argc,argv);
}
//---------------------------------------------------------------------------
