 /*
  * Unitex
  *
  * Copyright (C) 2001-2006 Universit de Marne-la-Valle <unitex@univ-mlv.fr>
  *
  * This library is free software; you can redistribute it and/or
  * modify it under the terms of the GNU Lesser General Public
  * License as published by the Free Software Foundation; either
  * version 2.1 of the License, or (at your option) any later version.
  *
  * This library is distributed in the hope that it will be useful,
  * but WITHOUT ANY WARRANTY; without even the implied warranty of
  * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
  * Lesser General Public License for more details.
  * 
  * You should have received a copy of the GNU Lesser General Public
  * License along with this library; if not, write to the Free Software
  * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA.
  *
  */

#ifndef KeyboardH
#define KeyboardH

#include "unicode.h"

#define PC_KEYBOARD_UPPER_LINE_SIZE 13  // number of keys in the digits keyboard line
#define PC_KEYBOARD_LINE_SIZE 12        // number of keys in a keyboard line
#define PC_KEYBOARD_LOWER_LINE_SIZE 11  // number of keys in the lowest keyboard line

#define NO_KEY_DEFINED 0

#define N_KEYBOARDS 7

struct keyboard {
   char name[128];
   char comment[1024];
   unichar low0[PC_KEYBOARD_UPPER_LINE_SIZE];
   unichar low1[PC_KEYBOARD_LINE_SIZE];
   unichar low2[PC_KEYBOARD_LINE_SIZE];
   unichar low3[PC_KEYBOARD_LOWER_LINE_SIZE];
   unichar up0[PC_KEYBOARD_UPPER_LINE_SIZE];
   unichar up1[PC_KEYBOARD_LINE_SIZE];
   unichar up2[PC_KEYBOARD_LINE_SIZE];
   unichar up3[PC_KEYBOARD_LOWER_LINE_SIZE];
   unichar alt0[PC_KEYBOARD_UPPER_LINE_SIZE];
   unichar alt1[PC_KEYBOARD_LINE_SIZE];
   unichar alt2[PC_KEYBOARD_LINE_SIZE];
   unichar alt3[PC_KEYBOARD_LOWER_LINE_SIZE];
};


int areCloseOnKeyboard(unichar,unichar);
int areCloseOnKeyboard(unichar,unichar,struct keyboard*);

static struct keyboard keyboards[N_KEYBOARDS];
static struct keyboard* current_keyboard=NULL;

struct keyboard* new_keyboard();
void free_keyboard(struct keyboard*);
void display_keyboard(struct keyboard*,FILE*);
void display_all_keyboards(FILE*);

int init_keyboards();

struct keyboard* get_keyboard(char*);

#endif

