 /*
  * Unitex
  *
  * Copyright (C) 2001-2005 Universit de Marne-la-Valle <unitex@univ-mlv.fr>
  *
  * This library is free software; you can redistribute it and/or
  * modify it under the terms of the GNU Lesser General Public
  * License as published by the Free Software Foundation; either
  * version 2.1 of the License, or (at your option) any later version.
  *
  * This library is distributed in the hope that it will be useful,
  * but WITHOUT ANY WARRANTY; without even the implied warranty of
  * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
  * Lesser General Public License for more details.
  * 
  * You should have received a copy of the GNU Lesser General Public
  * License along with this library; if not, write to the Free Software
  * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA.
  *
  */

//---------------------------------------------------------------------------
#ifndef Minimize_treeH
#define Minimize_treeH
//---------------------------------------------------------------------------

#include "Arbre_dico.h"


#define HAUTEUR_MAX 10000

#define MAX_TRANS ((sizeof(void*) > 4) ? 67108864 : 4194304 )
/* a hack to get bigger size on 64bit-architectures */

struct node_list {
   struct arbre_dico_trans* trans;
   struct node_list* suivant;
};

extern struct node_list* tab_by_hauteur[];
extern struct arbre_dico_trans* tab_trans[];


void minimize_tree(struct arbre_dico*);
int compare_nodes(struct arbre_dico_trans*,struct arbre_dico_trans*);
void init_tab_by_hauteur();
void free_tab_by_hauteur();
int sort_by_height(struct arbre_dico*);
void insert_trans_in_tab_by_hauteur(struct arbre_dico_trans*,int);
struct node_list* new_node_list();
int convert_list_to_array(unsigned int);
void quicksort(int, int);
void fusionner(int);

#endif
