 /*
  * Unitex
  *
  * Copyright (C) 2001-2006 Universit de Marne-la-Valle <unitex@univ-mlv.fr>
  *
  * This library is free software; you can redistribute it and/or
  * modify it under the terms of the GNU Lesser General Public
  * License as published by the Free Software Foundation; either
  * version 2.1 of the License, or (at your option) any later version.
  *
  * This library is distributed in the hope that it will be useful,
  * but WITHOUT ANY WARRANTY; without even the implied warranty of
  * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
  * Lesser General Public License for more details.
  * 
  * You should have received a copy of the GNU Lesser General Public
  * License along with this library; if not, write to the Free Software
  * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA.
  *
  */

#ifndef SpellCheckingH
#define SpellCheckingH

#include "unicode.h"
#include "BinList.h"
#include "Alphabet.h"
#include "SpellCheckHypothesis.h"

#include "Keyboard.h"

#define SIMPLE_WORDS -1

#define INVALID_OP_SEQUENCE 0
#define VALID_OP_SEQUENCE 1

#define SPELL_FRENCH 0

static int SPELL_LANGUAGE=SPELL_FRENCH;

int loadCharEquivalenceList(char*);
int areSpellEquivalentLetters(unichar,unichar);
int isSpellEquivalentWord(unichar*,unsigned char*);
int isSpellEquivalentWordModuloOneLetter(unichar*,unsigned char*,unichar*);
int isInDictionary(unichar*,unsigned char*,Alphabet*,int,struct hypothesis_list**,int);
int isInDictionaryModuloSeparators(unichar*,unsigned char*,Alphabet*,int,struct hypothesis_list**,int);

int getSimpleWordHypothesis(unichar*,struct bin_list*,Alphabet*,int,int,struct hypothesis_list**);
int getCompoundWordHypothesis(unichar*,struct bin_list*,Alphabet*,int,int,struct string_hash*,struct hypothesis_list**,int);

int index_of_first_non_letter(unichar*,Alphabet*);
int index_of_last_non_letter(unichar*,Alphabet*);
int beginning_of_next_token(unichar*,Alphabet*);

#endif

