 /*
  * Unitex
  *
  * Copyright (C) 2001-2006 Universit de Marne-la-Valle <unitex@univ-mlv.fr>
  *
  * This library is free software; you can redistribute it and/or
  * modify it under the terms of the GNU Lesser General Public
  * License as published by the Free Software Foundation; either
  * version 2.1 of the License, or (at your option) any later version.
  *
  * This library is distributed in the hope that it will be useful,
  * but WITHOUT ANY WARRANTY; without even the implied warranty of
  * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
  * Lesser General Public License for more details.
  * 
  * You should have received a copy of the GNU Lesser General Public
  * License along with this library; if not, write to the Free Software
  * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA.
  *
  */

//---------------------------------------------------------------------------
#include <stdio.h>
#include <stdlib.h>
#include <string.h>


#include "DELA.h"
#include "String_hash.h"
#include "unicode.h"
#include "Alphabet.h"
#include "Text_tokens.h"
#include "Dico_application.h"
#include "Liste_nombres.h"
#include "FileName.h"
#include "Token_tree.h"
#include "Table_complex_token_hash.h"
#include "AutomateFst2.h"
#include "LiberationFst2.h"
#include "Copyright.h"
#include "IOBuffer.h"
#include "LocateAsRoutine.h"
#include "Matches.h"



int main(char argv,char** argc) {
char nom_bin[1000];
char nom_inf[1000];
char nom_dic[1000];
strcpy(nom_bin,argc[1]);
name_without_extension(nom_bin,nom_inf);
strcat(nom_inf,".inf");
name_without_extension(nom_bin,nom_dic);
strcat(nom_dic,".dic");

FILE* dic=u_fopen(nom_dic,U_WRITE);
if (dic==NULL) {
   fprintf(stderr,"Cannot open %s\n",nom_dic);
   return 1;
}
unsigned char* bin=load_BIN_file(nom_bin);
struct INF_codes* inf=load_INF_file(nom_inf);
printf("Uncompressing %s...\n",nom_bin);
rebuild_dictionary(bin,inf,dic);
u_fclose(dic);
return 0;
}
//---------------------------------------------------------------------------
